#ifndef MAKEDEPEND
#include <ctime>
#endif

#include "expr_2op.h"

class expr_huuto : public expr
{
	exprp e;
public:
	expr_huuto(exprp ex)
	{
//		cout << "parametrin tuli " << ex->getname() << endl;
		e = ex;
		if(!e)
			valid = false;
		else if(e->isconst && e->type == str)
		{
			e = NULL;
			valid = false;
		}
//		cout << "nyt muuttuja on " << e->getname() << endl;
		type = num;
	}	
	expr_huuto(const expr_huuto &s) : expr(s)
	{
		e = s.e;
	}
	virtual exprp calculate(calculate_args) const
	{
		exprp res = new expr_huuto(e->calculate(calculate_call));
		return res->optimize();
	#if 0
		exprp t = e->calculate(calculate_call);
		if(!t->isconst || t->type!=num)
			retu: return new expr_huuto(*this);
		expr_floattype num = t->getnum(), intg;
		expr_floattype frac = expr_modf_fun(num, &intg);
		if(frac != 0 || intg < 0)goto retu;
		for(num=1; intg>1; )
		{
			expr_floattype res = num * intg--;
        //	cout.precision(20); cout << "testing " << res << " and " << res+res << endl;
			if(res == res+res) // infinity check
			{
		//		cout << "overflow!\n";
				return (new expr_2op(
					new expr_number(num),
					new expr_huuto(new expr_number(intg)),
					expr_times_fun))->optimize();
			}
			num = res;
		}
		return new expr_number(num);
	#endif
	}
	virtual exprp optimize()
	{
		e = e->optimize();
		if(!e->isconst || e->type!=num)return this;
		expr_floattype num = e->getnum(), intg;
		expr_floattype frac = expr_modf_fun(num, &intg);
		if(frac != 0 || intg < 0)return this;
		for(num=1; intg>1; )
		{
			expr_floattype res = num * intg--;
        //	cout.precision(20); cout << "testing " << res << " and " << res+res << endl;
			if(res == res+res) // infinity check
			{
		//		cout << "overflow!\n";
				return (new expr_2op(
					new expr_number(num),
					new expr_huuto(new expr_number(intg)),
					expr_times_fun))->optimize();
			}
			num = res;
		}
		return new expr_number(num);
	}
	virtual const string getname() const
	{
		return '(' + e->getname() + ")!";
	}
};
