#ifndef __EXPR__MP_dud2
#define __EXPR__MP_dud2

#ifndef MAKEDEPEND
#include <map>
#endif

#include "expr.h"
#include "expr_var.h"

class exprlist
{
	typedef expr_floattype counttype;
	class exprcount
	{
	public:
		counttype posi,nega;
		exprp ex;
		exprcount() : posi(0),nega(0) { }
	};	
	typedef map<string, exprcount> maptype;
	
	/*
		Sislt exprp -tyyppisi elementtej
		Niill on mr, joka voi olla negatiivinenkin
		Avain on expr->getname()
	*/
public:
	maptype mapp;
	typedef maptype::const_iterator const_iterator;
	typedef maptype::iterator iterator;
	
	const_iterator begin() const { return mapp.begin(); }
	const_iterator end() const   { return mapp.end(); }
	iterator begin() { return mapp.begin(); }
	iterator end()   { return mapp.end(); }
	const_iterator find(const string s) const { return mapp.find(s); }
	unsigned size() { return mapp.size(); }
	void clear() { mapp.clear(); }
	void erase(const string &name) { mapp.erase(mapp.find(name)); }
	void erase(iterator i) { mapp.erase(i); }
	void insert(exprp s, counttype count)
	{
		if(count==0.0)return;
		
		#if 0		
		if(s->ID == ext_number)
		{
			counttype *x = &((expr_number *)s)->number();
			count *= *x;
			*x = 1;
		}
		#endif
		
	//	cout << "Adding " << count << " times '" << s->getname() << "'\n";
		
		string name = s->getname();
		
		exprcount &ec = mapp[name];
		
		if(count<0)
			ec.nega -= count;
		else
			ec.posi += count;
		
		/*
		if(ec.nega==ec.posi)
		{
			erase(name);
			return;
		}
		*/
		
		if(!ec.ex)
		{
			// If this was new...
			ec.ex = s;
		}
	}
};

class expr_minusplus : public expr
{
	typedef exprlist jonotype;
	jonotype jono;
	
public:
	friend class expr_fractions;
	
	expr_minusplus()
	{
		ID = ext_minusplus;
	}
	void insert(exprp s, expr_floattype sum)
	{
		jono.insert(s, sum);
	}
	void insert(exprp s, char sign)
	{
		if(s->ID == ext_minusplus)
		{
			expr_minusplus *p = (expr_minusplus *)&*s;
			for(jonotype::iterator i = p->jono.begin(); i != p->jono.end(); ++i)
			{
				expr_floattype count = i->second.posi - i->second.nega;
				jono.insert(i->second.ex, (sign=='+' ? count : -count));
			}
			/* It's contents have been written, delete it. */
			p->jono.clear();
		}
		else
			jono.insert(s, sign=='+' ? 1 : -1);
	}
	virtual exprp optimize();
	virtual exprp calculate(calculate_args) const;
	virtual const string getname() const;
};

class expr_fractions : public expr
{
	typedef exprlist jonotype;
	jonotype jono;
	
public:
	friend class expr_minusplus;
	
	expr_fractions()
	{
		ID = ext_fractions;
	}
	void insert(exprp s, expr_floattype sum)
	{
		jono.insert(s, sum);
	}
	void insert(exprp s, expr_floattype pos, expr_floattype neg)
	{
		jono.insert(s, pos);
		jono.insert(s, -neg);
	}
	void insert(exprp s, char sign)
	{
		if(s->ID == ext_fractions)
		{
			expr_fractions *p = (expr_fractions *)&*s;
			for(jonotype::iterator i = p->jono.begin(); i != p->jono.end(); ++i)
			{
				expr_floattype pos = i->second.posi;
				expr_floattype neg = i->second.nega;
				jono.insert(i->second.ex, sign=='*' ? pos : neg);
				jono.insert(i->second.ex, sign=='*' ?-neg :-pos);
			}
			/* Contents have been written, clear it. */
			p->jono.clear();
		}
		else
			jono.insert(s, sign=='*' ? 1 : -1);
	}
	virtual exprp optimize();
	virtual exprp calculate(calculate_args) const;
	virtual const string getname() const;
};

#endif
