#ifndef MAKEDEPEND
#include <cstdio>	// sprintf
#include <string>
#endif

#include "expr_var.h"

const string expr_number::getname() const
{	
	char Buf[64];
	if(luku<0)
		sprintf(Buf, "(" expr_format ")", luku);
	else
		sprintf(Buf, expr_format, luku);
	return Buf;
}

const string expr_fraction::getname() const
{	
	char Buf[128];
	register expr_floattype A=a, B=b;
	if(A<0 && B<0)A=-A, B=-B; /* Negate if both <0 */
	sprintf(Buf, "(" expr_format " _/ " expr_format ")", A, B);
	return Buf;
}

const string expr_truth::getstr() const
{
	return value ? "1" : "0";
}

#ifdef DUD2

#include "obj.h"

expr *expr_variable::calculate(calculate_args) const
{
	obj *src = thisobj;
	
	string tmp = content;
Retry:
	unsigned n=tmp.find('.');
	if(n != tmp.npos)
	{
		string objname = tmp.substr(0, n-1);
		src = objname=="cmder" ? cmder : src->finditem(objname);
		tmp.erase(0, n);
		goto Retry;
	}
	multimap<string,func>::iterator i = src->funcs.find(tmp);
	
	/* Ekaksi katsotaan, onko se funktio. */
	
	if(i != src->funcs.end())
	{
		printer *saveprinter = src->prn;
		strprinter tempprinter(tmp);
		src->prn = &tempprinter;
		i->second.run(cmder, src);
		src->prn = saveprinter;
		return new expr_string(tmp);
	}
	
	/* Sitten oletetaan sen olevan muuttuja. */
	
//	cout << "All vars: \n";
	
//	obj::varstype::iterator j;
//	for(j=src->vars.begin(); j!=src->vars.end(); j++)
//	{
//		cout << "\t" << j->first << ": " << (void *)j->second << " (valid=" << (int)j->second->valid << ")\n";
//	}
	
//	cout << "Peek '" << tmp << "'\n";
	
	expr *a = src->vars[tmp];
	if(!a)
	{
		cout << "Error: Variable '" << tmp << "' does not exist\n";
		return NULL;
	}	
	return a->calculate(cmder, src);
}

exprp &expr_variable::getvar(calculate_args) const
{
	obj *src = thisobj;
	
	string tmp = content;
Retry:
	unsigned n=tmp.find('.');
	if(n != tmp.npos)
	{
		string objname = tmp.substr(0, n);
		src = objname=="cmder" ? cmder : src->finditem(objname);
		if(!src)
		{
			cout << "Error: base object '" << objname
			     << "' does not exist from '" << content
			     << "'\n";
			return thisobj->vars["#invalid"];
		}
		tmp.erase(0, n+1);
		goto Retry;
	}
	
	return src->vars[tmp];
}

obj *expr_variable::getobj(calculate_args) const
{
	globalmap::iterator i = globals.find(content);
	if(i != globals.end())
		return i->second;
		
	return getvar(calculate_call)->getobj(calculate_call);
}

#endif
